#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "args.h"

int arg_verbose = 0;
int arg_print_names = 0;
int arg_slerp_steps = 5;
int arg_scale_image = 0;
char * arg_zip_file = 0;
char * arg_bed_file = 0;
char * arg_mtn_name = "root";

int args_init(int argc, char ** argv)
{
  int i;
  
  for (i = 1; i < argc; i++)
  {
    if (argv[i][0] == '-' && argv[i][2] == 0)
    {
      switch (argv[i][1])
      {
        case 'm':
          i++;
          if (i == argc || argv[i][0] == '-')
          {
            fprintf(stderr, "no argument supplied for -m\n");
            i--;
            break;
          }
          arg_mtn_name = argv[i];
          break;

       case 'i':
         i++;
         if (i == argc || argv[i][0] == '-')
         {
           fprintf(stderr, "no argument supplied for -i\n");
           i--;
           break;
         }
         arg_slerp_steps = atoi(argv[i]);
         arg_slerp_steps = arg_slerp_steps > 0 ? arg_slerp_steps : 5;
         break;

       case 'n':
         arg_print_names = 1;
         break;

       case 's':
         arg_scale_image = 1;
         break;

       case 'v':
         arg_verbose = 1;
         break;

       default:
          fprintf(stderr, "unknown option %s\n", argv[i]);
          break;
      }
    } else
    {
      if (arg_bed_file != 0)
      {
        fprintf(stderr, "unknown argument %s\n", argv[i]);
      } else
      {
        arg_bed_file = strdup(argv[i]);
      }
    }
  }
  return 0;
}

