#include "config.h"

#include <stdlib.h>

#include "iff.h"
#include "skn.h"

#define SKIN MKNAME('S', 'K', 'I', 'N')
#define LINK MKNAME('L', 'I', 'N', 'K')

struct SkinTag * skn_init(struct IFFStreamTag * stream)
{
  struct SkinTag * Skin;
  struct IFFTag * skin = iff_init(stream);

  iff_size size;
  iff_name name = iff_readname(skin);

  IFFCHK(name != SKIN, skin);

  skin->name = name;
  skin->size -= 4;

  name = iff_readname(skin);
  size = iff_readsize(skin);
  IFFCHK(name != LINK, skin);
  IFFCHK(size != skin->size - 8, skin);

  Skin = malloc(SKINTAGSZ);
  IFFCHK(!Skin, skin);

  Skin->SkinList = malloc(size);
  IFFCHK(!Skin->SkinList, skin);

  Skin->SkinCount = size / 2;
  iff_readdata(skin, Skin->SkinList, size);
  iff_close(skin);
  return Skin;
}

#ifdef _TEST
int main(void)
{
  skn_init("lex.skn");
  return 0;
}
#endif
