#ifndef __skel_included
#define __skel_included

#include "config.h"

#include "iff/iff.h"
#include "iff/skl.h"

#include "strm.h"

#include "real.h"
#include "skin.h"

#include "cpppro.h"

#define SKTRTAGSZ sizeof(struct SktrTag)
struct SktrTag 
{
  struct SkelTag * skel;
  float * LimbListS;
  float * LimbListE;
  float * TempQuaternionList;
  float * SkelQuaternionList;
  float * ItrpQuaternionList;
  float * AQuaternionList;
  float * BQuaternionList;
  float * SinList;
  float * CosList;
  float * ULenList;
  float * VLenList;
  int SlerpStep;
  int SlerpStepCount;
};

DL_API(struct SktrTag *) skel_init(const char *);
DL_API(void) skel_done(struct SktrTag *);
DL_API(void) skel_process(struct SktrTag *,
                          struct RetrTag *,
                          struct SntrTag *);

DL_API(void) skel_apply(struct SktrTag *,
                        struct RetrTag *,
                        struct SntrTag *);

DL_API(void) skel_next(struct SktrTag * sktr,
                       struct RetrTag * retr,
                       struct SntrTag * sntr);

DL_API(void) skel_start(struct SktrTag * sktr);

#include "cppepi.h"

#endif /* __skel_included */
