#ifndef __vec_included
#define __vec_included

#include "config.h"

#include <math.h>

#define VECSIZE 3

#define VECNIL(v) (v)[0] = 0.f; (v)[1] = 0.f; (v)[2] = 0.f
#define VECCPY(l, r) (l)[0] = (r)[0]; (l)[1] = (r)[1]; (l)[2] = (r)[2]
#define VECDOT(l, r) ((l)[0] * (r)[0] + (l)[1] * (r)[1] + (l)[2] * (r)[2])
#define VECADD(l, r) (l)[0] += (r)[0]; (l)[1] += (r)[1]; (l)[2] += (r)[2]
#define VECSUB(l, r) (l)[0] -= (r)[0]; (l)[1] -= (r)[1]; (l)[2] -= (r)[2]
#define VECMAG(v) ((float) sqrt(VECDOT((v), (v))))
#define VECSCL(v, s) (v)[0] *= (s); (v)[1] *= (s); (v)[2] *= (s)
#define VECDIV(v, s) (v)[0] /= (s); (v)[1] /= (s); (v)[2] /= (s)
#define VECUNP(v) (v)[0], (v)[1], (v)[2]
#define VECPAK(v, x, y, z) (v)[0] = (float) (x); (v)[1] = (float) (y); (v)[2] = (float) (z)
#define VECNEG(v) (v)[0] = -(v)[0]; (v)[1] = -(v)[1]; (v)[2] = -(v)[2]
#define VECPRT(v) printf("vector(" #v "): x:%9f y:%9f z:%9f\n", VECUNP((v)))
#define VECCRS(l, r) \
{ \
  float v[VECSIZE]; \
  v[0] = (l)[1] * (r)[2] - (l)[2] * (r)[1]; \
  v[1] = (l)[2] * (r)[0] - (l)[0] * (r)[2]; \
  v[2] = (l)[0] * (r)[1] - (l)[1] * (r)[0]; \
  VECCPY(l, v); \
}

#endif /* __vec_included */
