# eor with LittleNesting
# each FORM chunk is in form FORM_CHUNK_SUBCHUNK_SUBSUBCHUNK_SUB...

# unknown chunks:
#   REAL.OBJT .EXTE .ORNT
#   REAL.APPR.POLY.ATTR 
#   REAL.APPR.POLY.GRUP

import iff

from iffutils import *

Chunk = iff.Chunk

TrisMapList = []
TrisFaceList = []
VertexList = []
TextureList = []
ObjectName = ''
LineFaceList = []
QuadFaceList = []
QuadMapList = []

class FORM_REAL(Chunk):
	def INFO(self):
		global ObjectName
                ObjectName = strip_zeros(self.file.read(self.ChunkSize))
		self.align()

class FORM_REAL_OBJT(Chunk): 
	def EXTE(self):
		self.SkipChunk()

class FORM_REAL_OBJT_ORNT(Chunk): pass

class FORM_REAL_APPR(Chunk): pass

class FORM_REAL_APPR_POLY(Chunk): 
	def INFO(self):
                # size 1? 
                self.SkipChunk()

       	def VERT(self):
                i = 0
                while i < self.ChunkSize / 12:
                        x = read_word(self.file)
                        y = read_word(self.file)
                        z = read_word(self.file)
                        VertexList.append((x, y, z))
                        i = i + 1

	def ATTR(self):
        # no idea what this is
        	self.SkipChunk()
        	
class FORM_REAL_APPR_POLY_DETA(Chunk):
	def LVL0(self): self.SkipChunk()

class FORM_REAL_APPR_POLY_TXMS(Chunk):
	def INFO(self):
		textures = read_half(self.file)
		animated = read_half(self.file)

	def TXMP(self):
		name = strip_zeros(self.file.read(8))
                xres = read_half(self.file)
		yres = read_half(self.file)
		TextureList.append((name, xres, yres, self.file.tell(), 0))
		self.file.seek(self.ChunkSize - 12, 1)
		self.align()

	def TXMA(self):                                         
		name = strip_zeros(self.file.read(8))
		xres = read_half(self.file)
		yres = read_half(self.file)
		frames = read_half(self.file)
		TextureList.append((name, xres, yres, self.file.tell(), frames))
		self.file.seek(self.ChunkSize - 14, 1)
		self.align()

	def TXMD(self):
		self.SkipChunk()

class FORM_REAL_APPR_POLY_TRIS(Chunk):
	def FACE(self):
		i = 0
		while i < self.ChunkSize / 8:
			# whats p i dont know
			p = read_half(self.file)
			a = read_half(self.file)
			b = read_half(self.file)
			c = read_half(self.file)
			TrisFaceList.append((a, b, c, p))
			i = i + 1

	def MAPS(self):
		i = 0
		while i < self.ChunkSize / 16:
			mapid = read_half(self.file)
			texture = read_half(self.file)
			x1 = read_half(self.file)
			y1 = read_half(self.file)
			x2 = read_half(self.file)
			y2 = read_half(self.file)
			x3 = read_half(self.file)
			y3 = read_half(self.file)
			TrisMapList.append((mapid, texture, (x1, y1), (x2, y2), (x3, y3)))
			i = i + 1

class FORM_REAL_APPR_POLY_LINE(Chunk):
	def FACE(self):
                i = 0
                while i < self.ChunkSize / 6:
                        # whats p i dont know
                        p = read_half(self.file)
                        a = read_half(self.file)
                        b = read_half(self.file)
                        LineFaceList.append((a, b, p))
                        i = i + 1

class FORM_REAL_APPR_POLY_QUAD(Chunk):
	def FACE(self):
		i = 0
                while i < self.ChunkSize / 10:
			# whats p i dont know
                        p = read_half(self.file)
			a = read_half(self.file)
			b = read_half(self.file)
			c = read_half(self.file)
			d = read_half(self.file)
                        QuadFaceList.append((a, b, c, d, p))
			i = i + 1

	def MAPS(self):
        	i = 0
                while i < self.ChunkSize / 20:
                	mapid = read_half(self.file)
                        textureid = read_half(self.file)
                        x1 = read_half(self.file)
                        y1 = read_half(self.file)
                        x2 = read_half(self.file)
                        y2 = read_half(self.file)
                        x3 = read_half(self.file)
                        y3 = read_half(self.file)
                        x4 = read_half(self.file)
                        y4 = read_half(self.file)
                        QuadMapList.append((mapid, textureid, (x1, y1), (x2, y2), (x3, y3), (x4, y4)))
                        i = i + 1

iff.add_chunks(vars())
iff.LittleNesting = 1
